﻿using Monorail.DrawningObjects;
using Monorail.Entities;
using System;
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Monorail.Generics
{
    internal class DrawningMonorailEqutables : IEqualityComparer<DrawningMonorail?>
    {
        public bool Equals(DrawningMonorail? x, DrawningMonorail? y)
        {
            if(x == null || x.EntityMonorail == null)
            {
                throw new ArgumentNullException(nameof(x));
            }
            if (y == null || y.EntityMonorail == null)
            {
                throw new ArgumentNullException(nameof(y));
            }
            if(x.GetType().Name != y.GetType().Name)
            {
                return false;
            }
            if (x.EntityMonorail.Speed != y.EntityMonorail.Speed)
            {
                return false;
            }
            if (x.EntityMonorail.Weight != y.EntityMonorail.Weight)
            {
                return false;
            }
            if (x.EntityMonorail.BodyColor != y.EntityMonorail.BodyColor)
            {
                return false;
            }
            if(x is DrawningLocomotive && y is DrawningLocomotive)
            {
                EntityLocomotive EntityX = (EntityLocomotive)x.EntityMonorail;
                EntityLocomotive EntityY = (EntityLocomotive)y.EntityMonorail;
                if (EntityX.AddWheelsNumb != EntityY.AddWheelsNumb)
                    return false;
                if (EntityX.SecondCabine != EntityY.SecondCabine)
                    return false;
                if (EntityX.MagniteRail != EntityY.MagniteRail)
                    return false;
                if (EntityX.AdditionalColor != EntityY.AdditionalColor)
                    return false;
            }
            return true;
        }

        public int GetHashCode([DisallowNull] DrawningMonorail obj)
        {
            return obj.GetHashCode();
        }
    }
}
