﻿using Monorail.DrawningObjects;
using Monorail.Entities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Monorail.Generics
{
    internal class MonorailCompareByColor : IComparer<DrawningMonorail?>
    {
        public int Compare(DrawningMonorail? x, DrawningMonorail? y)
        {
            if (x == null || x.EntityMonorail == null)
                throw new ArgumentNullException(nameof(x));

            if (y == null || y.EntityMonorail == null)
                throw new ArgumentNullException(nameof(y));

            if (x.EntityMonorail.BodyColor.Name != y.EntityMonorail.BodyColor.Name)
            {
                return x.EntityMonorail.BodyColor.Name.CompareTo(y.EntityMonorail.BodyColor.Name);
            }
            if (x.GetType().Name != y.GetType().Name)
            {
                if (x is DrawningMonorail)
                    return -1;
                else
                    return 1;
            }
            if (x.GetType().Name == y.GetType().Name && x is DrawningLocomotive)
            {
                EntityLocomotive EntityX = (EntityLocomotive)x.EntityMonorail;
                EntityLocomotive EntityY = (EntityLocomotive)y.EntityMonorail;
                if(EntityX.AdditionalColor.Name != EntityY.AdditionalColor.Name)
                {
                    return EntityX.AdditionalColor.Name.CompareTo(EntityY.AdditionalColor.Name);
                }
            }
            var speedCompare = x.EntityMonorail.Speed.CompareTo(y.EntityMonorail.Speed);

            if (speedCompare != 0)
                return speedCompare;

            return x.EntityMonorail.Weight.CompareTo(y.EntityMonorail.Weight);
        }
    }
}
